#!/usr/bin/perl

use Net::UPnP::ControlPoint;
use CGI;

require './conf.cgi';

$q = new CGI;
$q_action = $q->param('action');
$p_dmp = $q->param('ddmp');

$dmp = $p_dmp;
$dmp =~ s/\+/ /g;
$dmp =~ s/%([0-9a-fA-F]{2})/pack("H2",$1)/eg;
$dmp =~ /(.*)\\(.*)/;
$dmp_name = $1;
$dmp_host = $2;

$p_dmp =~ s/([^ 0-9a-zA-Z])/"%".uc(unpack("H2",$1))/eg;
$p_dmp =~ s/ /+/g;



print "Content-type: text/html\n\n";
print "<html>\n";
print "<head><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf8\">";
print "<body>";

        $upnpa = Net::UPnP::ControlPoint->new();
        @devsa = $upnpa->search(st => 'upnp:rootdevice', mx => ${search_time1},host =>${dmp_host});
        foreach $deva(@devsa){
                if($deva->getfriendlyname()=~ /$dmp_name/){
                        $dev=$deva;
                }
        }
print "friendlyname : ";
print $dev->getfriendlyname();
print "<br>\n";
print "${q_action}<br>\n";

$serv = $dev->getservicebyname(
             'urn:schemas-upnp-org:service:AVTransport:1');
$inarg{'InstanceID'} = "0";

if ($q_action eq "Play"){
$inarg{'Speed'} = $q->param('speed');
}


$resp = $serv->postaction("$q_action", \%inarg);
if ($resp->getstatuscode() != 200) {
        print "ERROR : status code ";
        print $resp->getstatuscode();
        print "\n";
}

print "\n";
print "<!-- $media_item -->\n";
print "</body></html>\n";
