#!/usr/bin/perl

use Net::UPnP::ControlPoint;
use CGI;
#use Data::Dumper;
#use Storable qw(nfreeze thaw);

require './conf.cgi';

$q = new CGI;
$p_id = $q->param('id');
$p_dmr = $q->param('ddmr');
$p_dmp = $q->param('ddmp');


$dmr = $p_dmr;
$dmr =~ s/\+/ /g;
$dmr =~ s/%([0-9a-fA-F]{2})/pack("H2",$1)/eg;
$dmr =~ /(.*)\\(.*)/;
$dmr_name = $1;
$dmr_host = $2;


$dmp = $p_dmp;
$dmp =~ s/\+/ /g;
$dmp =~ s/%([0-9a-fA-F]{2})/pack("H2",$1)/eg;
$dmp =~ /(.*)\\(.*)/;
$dmp_name = $1;
$dmp_host = $2;

$re_id = $p_id;
if (!($re_id =~ s/(.*)\$(.*)/$1/)){
$re_id = 0;
}
if($p_id eq ""){
	$p_id = 0;
}

$p_dmr =~ s/([^ 0-9a-zA-Z])/"%".uc(unpack("H2",$1))/eg;
$p_dmr =~ s/ /+/g;
$p_dmp =~ s/([^ 0-9a-zA-Z])/"%".uc(unpack("H2",$1))/eg;
$p_dmp =~ s/ /+/g;

print "Content-type: text/html\n\n";
print "<html>\n";
print "<head><meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf8\">\n";
print "<title>UPNP メディアコントローラー：MediConWEB</title></head>\n";
print "<body>$dmr_neme\n";

$upnp = Net::UPnP::ControlPoint->new();
@devs = $upnp->search(st => 'upnp:rootdevice', mx => ${search_time2},host => ${dmr_host});
$i = 0;
$dev="";
foreach $deva(@devs){
	if($deva->getfriendlyname()=~ /$dmr_name/){
		$dev=$deva;
#		print $deva->getfriendlyname();
	}
}
#@servlist = $dev->getservicelist();
print "メディアサーバ　　：${dmr_name}<br>\n";
print "メディアレンダラー：${dmp_name}<br>\n";
print "<br>\n";

if($dev eq ""){
print "一覧が表示されない場合、タイムアウトの可能性があります。<br>conf.cgi search_time2の値が小さい可能性があります。<br><br>\n";
print "<a href=./upnp.cgi?id=0>ホーム</a><br><br>\n";
}

$serv = $dev->getservicebyname(
             'urn:schemas-upnp-org:service:ContentDirectory:1');

$inarg{'ObjectID'} = "$p_id";
$inarg{'BrowseFlag'} = "BrowseDirectChildren";
$inarg{'Filter'} = "0";
$inarg{'StartingIndex'} = "0";
$inarg{'RequestedCount'} = "1000";
$inarg{'SortCriteria'} = "";

$resp = $serv->postaction('Browse', \%inarg);

if ($resp->getstatuscode() != 200) {
	print "ERROR : status code ";
	print $resp->getstatuscode();
	print "\n";
	next;
}

$args = $resp->getargumentlist();
$media_item=$args->{'Result'};

print "\n\n";
print "<!-- $media_item -->";
print "\n";

@media_list = $media_item =~ /<containe.*?<\/container>/g;
 
print "<a href=./upnp.cgi?id=0>ホーム</a><br><br>\n";

if($p_id ne "0"){
	print "<a href=./upnp2.cgi?id=$re_id&ddmr=$p_dmr&ddmp=$p_dmp>上へ</a><br>\n";
}

$i=0;
foreach $container ( @media_list ) {
	$title = $container;
	$title=~ s/<container.*<dc:title>(.*)<\/dc:title>.*/$1/;
	$url = $container;
	$url =~ s/<container id=\"(.*?)\" parentID.*/$1/;
	print "<a href=./upnp2.cgi?id=$url&ddmr=$p_dmr&ddmp=$p_dmp>${title}</a><br>\n\n";
}

print "<br>\n";

$media_item =~ s/<containe.*?<\/container>//g;
@media_class= $media_item =~ /<upnp:class>object\.item\..*?<\/upnp:class>/g;
@media_list = $media_item =~ /<dc:title>.*?<\/dc:title>/g;
@media_url  = $media_item =~ /<res.*?>.*?<\/res>/g;

($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);
#$year += 1900;
$mon += 1;
#print "$year年$mon月$mday日($youbi[$wday]) $hour時$min分$sec秒\n";

$i=0;
foreach $title ( @media_list ) {
	$title=~ s/<dc:title>(.*)<\/dc:title>/$1/;
	$url = @media_url[$i];
	$url =~ s/<res.*>(.*)<\/res>/$1/;
	$oclass = @media_class[$i++];
	$oclass =~ s/<upnp:class>object\.item\.(.*)<\/upnp:class>/$1/;
	print "[${oclass}]<a href=./action_play.cgi?q_url=${url}&ddmp=${p_dmp}&pday=${mon}${mday} target=play>${title}</a><br>\n";  
}

print "<br>\n\n";
print "<iframe name=play width=500 height=100 src=\"blank.html\"></iframe><br>\n";

print "<input type=button onClick=\"window.open(\'./action.cgi?action=Play&ddmp=${p_dmp}&speed=-120\',\'play\')\" value=＜＜＜戻る>\n";
print "<input type=button onClick=\"window.open(\'./action.cgi?action=Play&ddmp=${p_dmp}&speed=-30\',\'play\')\" value=＜＜戻る>\n";
print "<input type=button onClick=\"window.open(\'./action.cgi?action=Play&ddmp=${p_dmp}&speed=-10\',\'play\')\" value=＜戻る>\n";
print "<input type=button onClick=\"window.open(\'./action.cgi?action=Play&ddmp=${p_dmp}&speed=1\',\'play\')\" value=再生>\n";
print "<input type=button onClick=\"window.open(\'./action.cgi?action=Play&ddmp=${p_dmp}&speed=10\',\'play\')\" value=進む＞>\n";
print "<input type=button onClick=\"window.open(\'./action.cgi?action=Play&ddmp=${p_dmp}&speed=30\',\'play\')\" value=進む＞＞>\n";
print "<input type=button onClick=\"window.open(\'./action.cgi?action=Play&ddmp=${p_dmp}&speed=120\',\'play\')\" value=進む＞＞＞><br>\n";
print "<input type=button onClick=\"window.open(\'./action.cgi?action=Stop&ddmp=${p_dmp}\',\'play\')\" value=停止>\n";
print "<input type=button onClick=\"window.open(\'./action.cgi?action=Pause&ddmp=${p_dmp}\',\'play\')\" value=一時停止>\n";

print "</body></html>";
exit;
